Exiting out of the script


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting Exiting out of the script
# 1  
Old 09-24-2010
Exiting out of the script

I have to write a script in ksh which again should call another script. Say A.ksh is calling B.ksh. Now in B.ksh if the condition we are checking for is true then we have to go back to the main script A.ksh or if the condition in B.ksh is false then we have to totally come out of the scripts.
I have written a sample code and trying to achive the functionality mentioned above. In case of successs i was able to come back to the main script but even in case of failure it is coming back to main script A.ksh which is not wanted. Below are the sample scripts i am working on.

A.ksh
Code:
while [ 1 ]
do
for file in `ls /home/inputfile/*.dat`
do
        tc=/home/oracle/db.log
        string=`sqlplus user/pass <<EOF >$tc
        set serveroutput on;
        select 'DATABASE IS UP' from dual;
        exit;
        EOF`
        if grep 'DATABASE IS UP' $tc; then
            cd /home/oracle/test/
            ./echoing.ksh
        else
            echo "db is down"
        fi
done
sleep 5
done

B.ksh
Code:
echo "db is up so came into new script"
if grep 'error files' /home/oracle/db.log; then
    echo "file has the word wanted to check for"
    echo "now the script should go back to main script"
    sleep 5
    cd /home/oracle/test/
    ./ods.ksh
else
    echo "error hence coming out"
fi

# 2  
Old 09-24-2010
I missed the line where A.ksh is calling B.ksh, so here's how...

Have A.ksh add these lines:

Code:
B.ksh

if [[ $? -ne 0 ]]; then
  exit 1
fi

and B.ksh has:

Code:
if [[ $some_condition_fails -eq 1 ]]; then
  exit 1
else
  exit 0
fi

ta da.
echo "db is up so came into new script"
if grep 'error files' /home/oracle/db.log; then
echo "file has the word wanted to check for"
echo "now the script should go back to main script"
sleep 5
cd /home/oracle/test/
./ods.ksh
else
echo "error hence coming out"
fi
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Help for exiting the function not script

function2() { cmd1 cmd2 cmd3 .... cmdn } function2() { cmd11 cmd12 cmd13 .... .... } for i in {1,2} (7 Replies)
Discussion started by: yanglei_fage
7 Replies

2. Shell Programming and Scripting

Exiting from the script abruptly

Hi Team, Need your help for the below code snippet. I wrote a module to read the file names remote server using file name convention. Issue : My script is coming out from while loop without reading complete file. test1() { while read line do echo $line file_nm_convention=`echo... (3 Replies)
Discussion started by: gvkumar25
3 Replies

3. Shell Programming and Scripting

Exiting the script if the character is not recognized

Below is the script that i'm using but i'm getting an error, echo -n "Read the letter >(enter a or b or c) " read letter if || || ; then echo "unacceptable character" else echo "Character Accepted" fi if the character entered is not equal to a or b or c, the script should... (6 Replies)
Discussion started by: web2moha
6 Replies

4. Shell Programming and Scripting

Exiting from Minicom on a shell script

This is what I've tried: #!/bin/sh send sh send showifs send exit ! killall minicom My problem is that for some reason when I do this it doesn't give me the results of the prior commands sent like showifs So I suspect my syntax is wrong. (1 Reply)
Discussion started by: uradunce
1 Replies

5. Shell Programming and Scripting

Bash Script Not Exiting

I have a script planned for the Helpdesk to allow them to (on a couple of RHEL 3 / RHEL 5 servers) reset passwords, stop / start printers, and clear print queues. The appropriate sudo permissions were given to their accounts, and the individual functions all work just fine. The ability to move... (0 Replies)
Discussion started by: tearsong
0 Replies

6. Shell Programming and Scripting

exiting from script

Hi, I am trying to exit the script from a function. I was in assumption that if we use exit ( inside or outside the function) it will exit from the script. alternatively, return will exit from that particular function. but in my case, exit is exiting from the function and not the script.... (8 Replies)
Discussion started by: shellwell
8 Replies

7. Shell Programming and Scripting

Exiting a script

I have a script abc.sh. Its contents are as follows: (7 Replies)
Discussion started by: lassimanji
7 Replies

8. Shell Programming and Scripting

Script is not exiting from run mode.

Hi Folks. My script is not exiting after run though its working correctly please suggest. #!/bin/ksh trap '' HUP . /bin/functions config_env PATH=/bin:/usr/bin:/usr/local/bin:$EXEC_PATH:$ORACLE_HOME/bin MONTH=$(control_register month) YEAR=$(control_register year) DATE_NOW="Job... (1 Reply)
Discussion started by: Haque123
1 Replies

9. Shell Programming and Scripting

exiting from script

there are many script in my project.i am having a problem when i am trying to quit from child script.what is the command to wrap up all the parent script and calling script as well? exit 0 is not working.please help.... (1 Reply)
Discussion started by: arghya_owen
1 Replies

10. Shell Programming and Scripting

Exiting from script when error occurs

Hi Friends, Is it possible to exit nicely(ie, to echo a message with the error occurred) from a shell script(quiet a big one :)) once it encounter an error in between the lines? For example, in my script I am calling the command mkdir and sometimes (when the directory already exists) it... (4 Replies)
Discussion started by: Sreejith_VK
4 Replies
Login or Register to Ask a Question